package FromDualMySQLmysql;

#
# Copyright (C) 2010 FromDual
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

use strict;
use warnings;
use FromDualMySQLagent ':stooges';

sub processMysqlInformation {

  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = ('max_connections', 'max_user_connections'
  , 'query_cache_size'
  , 'table_definition_cache', 'table_open_cache', 'table_cache'
  , 'alive', 'version'
  );

  my @aGlobalStatusToSend = ('Aborted_clients', 'Aborted_connects', 'Bytes_received', 'Bytes_sent'
  , 'Com_call_proc'
  , 'Com_delete', 'Com_delete_multi', 'Com_insert', 'Com_insert_select', 'Com_replace', 'Com_replace_select', 'Com_select'
  , 'Com_update', 'Com_update_multi'
  , 'Connections', 'Created_tmp_disk_tables', 'Created_tmp_tables'
  , 'Handler_delete', 'Handler_read_first', 'Handler_read_key', 'Handler_read_next', 'Handler_read_prev'
  , 'Handler_read_rnd', 'Handler_read_rnd_next', 'Handler_update', 'Handler_write'
  , 'Max_used_connections'
  , 'Opened_tables', 'Opened_table_definitions', 'Open_tables', 'Open_table_definitions'
  , 'Qcache_free_blocks', 'Qcache_free_memory', 'Qcache_hits'
  , 'Qcache_inserts', 'Qcache_lowmem_prunes', 'Qcache_not_cached', 'Qcache_queries_in_cache', 'Qcache_total_blocks'
  , 'Queries', 'Questions'
  , 'Select_full_join', 'Select_full_range_join', 'Select_range_check', 'Select_scan', 'Slow_queries'
  , 'Sort_merge_passes', 'Sort_range', 'Sort_rows', 'Sort_scan'
  , 'Table_locks_immediate', 'Table_locks_waited'
  , 'Threads_cached', 'Threads_connected', 'Threads_created', 'Threads_running'
  , 'Uptime', 'Access_denied_errors', 'Binlog_bytes_written', 'Handler_read_last'
  , 'Binlog_cache_disk_use', 'Binlog_cache_use', 'Created_tmp_files', 'Opened_files'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  $hGlobalVariables{'alive'} = 0;
  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  if ( ! defined($dbh) ) {
    return -1;
  }

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  my $count = keys %hGlobalVariables;
  if ( $count > 0 ) {
    $hGlobalVariables{'alive'} = 1;
  }

  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection($dbh);

  # Do some post calculations

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__